'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Stream = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* @flow */

var _fantasyLand = require('fantasy-land');

var _fantasyLand2 = _interopRequireDefault(_fantasyLand);

var _main = require('./main');

var _main2 = _interopRequireDefault(_main);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Stream = exports.Stream = function () {

  // Example:
  //
  //    const myWrappedStream = new Stream(sink => {
  //      sink(1)
  //      retrun () => {}
  //    })
  //

  function Stream(basicStream) {
    _classCallCheck(this, Stream);

    // The wrapped BasicStream is available as `wrapped.observe`.
    // You can call it as a method in order to subscribe to the stream:
    //
    //    const usub = wrapped.observe(callback)
    //    unsub()
    //
    // Or you can use `wrapped.observe` to extract BasicStream from the wrapper e.g.:
    //
    //    const basicStream2 = map(x => x * 2)(wrapped.observe)
    //
    this.observe = _main2.default.fromLoose(basicStream);
  }

  // Semigroup


  _createClass(Stream, [{
    key: _fantasyLand2.default.concat,
    value: function value(other) {
      return new Stream(_main2.default.concat([this.observe, other.observe]));
    }

    // Monoid

  }, {
    key: _fantasyLand2.default.empty,
    value: function value() {
      return Stream.empty();
    }

    // Functor

  }, {
    key: _fantasyLand2.default.map,
    value: function value(f) {
      return new Stream(_main2.default.map(f)(this.observe));
    }

    // Apply

  }, {
    key: _fantasyLand2.default.ap,
    value: function value(other) {
      var streamF = this.observe;
      return new Stream(_main2.default.ap(streamF)(other.observe));
    }

    // Applicative

  }, {
    key: _fantasyLand2.default.of,
    value: function value(x) {
      return Stream.of(x);
    }

    // Monad

  }, {
    key: _fantasyLand2.default.chain,
    value: function value(f) {
      return new Stream(_main2.default.chain(function (x) {
        return f(x).observe;
      })(this.observe));
    }

    // ------------------ Not from FL ------------------

  }, {
    key: 'filter',
    value: function filter(f) {
      return new Stream(_main2.default.filter(f)(this.observe));
    }
  }, {
    key: 'scan',
    value: function scan(f, seed) {
      return new Stream(_main2.default.scan(f, seed)(this.observe));
    }
  }, {
    key: 'chainLatest',
    value: function chainLatest(f) {
      return new Stream(_main2.default.chainLatest(function (x) {
        return f(x).observe;
      })(this.observe));
    }
  }, {
    key: 'take',
    value: function take(n) {
      return new Stream(_main2.default.take(n)(this.observe));
    }
  }, {
    key: 'takeWhile',
    value: function takeWhile(f) {
      return new Stream(_main2.default.takeWhile(f)(this.observe));
    }
  }, {
    key: 'takeUntil',
    value: function takeUntil(other) {
      return new Stream(_main2.default.takeUntil(other.observe)(this.observe));
    }
  }, {
    key: 'skip',
    value: function skip(n) {
      return new Stream(_main2.default.skip(n)(this.observe));
    }
  }, {
    key: 'skipWhile',
    value: function skipWhile(f) {
      return new Stream(_main2.default.skipWhile(f)(this.observe));
    }
  }, {
    key: 'skipDuplicates',
    value: function skipDuplicates(f) {
      return new Stream(_main2.default.skipDuplicates(f)(this.observe));
    }
  }, {
    key: 'multicast',
    value: function multicast() {
      return new Stream(_main2.default.multicast(this.observe));
    }
  }, {
    key: 'startWith',
    value: function startWith(x) {
      return new Stream(_main2.default.startWith(x)(this.observe));
    }
  }, {
    key: 'transduce',
    value: function transduce(transducer) {
      return new Stream(_main2.default.transduce(transducer)(this.observe));
    }
  }], [{
    key: _fantasyLand2.default.empty,
    value: function value() {
      return new Stream(_main2.default.empty());
    }
  }, {
    key: _fantasyLand2.default.of,
    value: function value(x) {
      return new Stream(_main2.default.of(x));
    }
  }, {
    key: 'map2',
    value: function map2(f) {
      var lifted = _main2.default.map2(f);
      return function (sA, sB) {
        return new Stream(lifted(sA.observe, sB.observe));
      };
    }
  }, {
    key: 'map3',
    value: function map3(f) {
      var lifted = _main2.default.map3(f);
      return function (sA, sB, sC) {
        return new Stream(lifted(sA.observe, sB.observe, sC.observe));
      };
    }
  }, {
    key: 'combineArray',
    value: function combineArray(arr) {
      return new Stream(_main2.default.combineArray(arr.map(function (x) {
        return x.observe;
      })));
    }
  }, {
    key: 'combineObject',
    value: function combineObject(obj) {
      var ofBasicStreams = {};
      Object.keys(obj).forEach(function (key) {
        ofBasicStreams[key] = obj[key].observe;
      });
      return new Stream(_main2.default.combineObject(ofBasicStreams));
    }
  }]);

  return Stream;
}();