(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (factory((global.BasicStreams = global.BasicStreams || {})));
}(this, function (exports) { 'use strict';

  function __commonjs(fn, module) { return module = { exports: {} }, fn(module, module.exports), module.exports; }


  var babelHelpers = {};

  babelHelpers.classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  babelHelpers.createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  babelHelpers.toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };

  babelHelpers;

  var index = __commonjs(function (module) {
  module.exports = {
    equals: 'equals',
    concat: 'concat',
    empty: 'empty',
    map: 'map',
    ap: 'ap',
    of: 'of',
    reduce: 'reduce',
    sequence: 'sequence',
    chain: 'chain',
    extend: 'extend',
    extract: 'extract'
  }
  });

  var fl = (index && typeof index === 'object' && 'default' in index ? index['default'] : index);

  var babelHelpers$1 = {};

  babelHelpers$1.extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  babelHelpers$1.toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };

  function flow(value) {
    for (var _len = arguments.length, fns = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      fns[_key - 1] = arguments[_key];
    }

    return fns.reduce(function (x, fn) {
      return fn(x);
    }, value);
  }

  function _curry(length, received, fn) {
    return function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var all = received.concat(args);
      return all.length >= length ? fn.apply(undefined, babelHelpers$1.toConsumableArray(all)) : _curry(length, all, fn);
    };
  }

  function curry(fn) {
    if (fn.__fnatasyLandStaticCurried__) {
      return fn;
    }
    var curried = _curry(fn.length, [], fn);
    curried.__fnatasyLandStaticCurried__ = true;
    return curried;
  }

  var mapObj = curry(function (fn, obj) {
    var result = {};
    Object.keys(obj).forEach(function (key) {
      result[key] = fn(obj[key]);
    });
    return result;
  });

  var curryAll = mapObj(curry);

  var map2 = curry(function (T, fn, t1, t2) {
    return T.ap(T.map(curry(fn), t1), t2);
  });

  var map3 = curry(function (T, fn, t1, t2, t3) {
    return T.ap(T.ap(T.map(curry(fn), t1), t2), t3);
  });

  var ap = curry(function (T, tf, tx) {
    return T.chain(function (f) {
      return T.map(f, tx);
    }, tf);
  });

  var reduce = curry(function (T, fn, seed, tx) {
    return T.toArray(tx).reduce(fn, seed);
  });

  var toArray = curry(function (T, tx) {
    return T.reduce(function (r, i) {
      return r.concat([i]);
    }, [], tx);
  });

  var mapViaApplicative = curry(function (T, fn, tx) {
    return T.ap(T.of(fn), tx);
  });

  var mapViaMonad = curry(function (T, fn, tx) {
    return T.chain(function (x) {
      return T.of(fn(x));
    }, tx);
  });

  var traverse = curry(function (T, Inner, fn, tx) {
    return T.sequence(Inner, T.map(fn, tx));
  });

  var join = curry(function (T, tt) {
    return T.chain(function (t) {
      return t;
    }, tt);
  });

  var chain = curry(function (T, fn, tx) {
    return T.join(T.map(fn, tx));
  });

  var deriveAll = function deriveAll(T) {

    var added = {};

    if (T.join === undefined && T.chain) {
      added.join = join(T);
    }

    if (T.chain === undefined && T.join) {
      added.chain = chain(T);
    }

    if (T.map === undefined && T.of && T.chain) {
      added.map = mapViaMonad(T);
    }

    if (T.ap === undefined && T.map && T.chain) {
      added.ap = ap(T);
    }

    if (T.map2 === undefined && T.ap && T.map) {
      added.map2 = map2(T);
    }

    if (T.map3 === undefined && T.ap && T.map) {
      added.map3 = map3(T);
    }

    if (T.map === undefined && T.of && T.ap) {
      added.map = mapViaApplicative(T);
    }

    if (T.reduce === undefined && T.toArray) {
      added.reduce = reduce(T);
    }

    if (T.toArray === undefined && T.reduce) {
      added.toArray = toArray(T);
    }

    if (T.traverse === undefined && T.map && T.sequence) {
      added.traverse = traverse(T);
    }

    return babelHelpers$1.extends({}, T, added);
  };

  var derive = Object.freeze({
    map2: map2,
    map3: map3,
    ap: ap,
    reduce: reduce,
    toArray: toArray,
    mapViaApplicative: mapViaApplicative,
    mapViaMonad: mapViaMonad,
    traverse: traverse,
    join: join,
    chain: chain,
    deriveAll: deriveAll
  });

  function fromIncomplete(T) {
    return curryAll(deriveAll(T));
  }

  var SArray = fromIncomplete({
    equals: function equals(a, b) {
      if (a.length !== b.length) {
        return false;
      }
      for (var i = 0; i < a.length; i++) {
        if (a[i] !== b[i]) {
          return false;
        }
      }
      return true;
    },
    of: function of(x) {
      return [x];
    },
    empty: function empty() {
      return [];
    },
    concat: function concat(a, b) {
      return a.concat(b);
    },
    map: function map(fn, arr) {
      return arr.map(function (x) {
        return fn(x);
      });
    },
    sequence: function sequence(T, arr) {
      return arr.reduce(T.map2(function (r, i) {
        return r.concat([i]);
      }), T.of([]));
    },
    toArray: function toArray(arr) {
      return arr;
    },
    chain: function chain(fn, arr) {
      return SArray.reduce(SArray.concat, SArray.empty(), arr.map(fn));
    }
  });

  var SId = fromIncomplete({
    equals: function equals(idA, idB) {
      return idA === idB;
    },
    of: function of(x) {
      return x;
    },
    map: function map(fn, idX) {
      return fn(idX);
    },
    reduce: function reduce(fn, seed, idX) {
      return fn(seed, idX);
    },
    chain: function chain(fn, idX) {
      return fn(idX);
    },
    sequence: function sequence(T, idT) {
      return idT;
    },
    extract: function extract(idX) {
      return idX;
    },
    extend: function extend(fn, idX) {
      return SId.of(fn(idX));
    }
  });

  var SPair = fromIncomplete({
    map: function map(fn, pairX) {
      return SPair.create(fn(pairX.first), pairX.second);
    },
    sequence: function sequence(T, pairT) {
      return T.map(SPair.createInverse(pairT.second), pairT.first);
    },
    create: function create(first, second) {
      return { first: first, second: second };
    },
    createInverse: function createInverse(second, first) {
      return { first: first, second: second };
    },
    first: function first(pairT) {
      return pairT.first;
    },
    second: function second(pairT) {
      return pairT.second;
    }
  });

  var SObject = fromIncomplete({

    map: mapObj,

    equals: function equals(objA, objB) {
      var keysA = Object.keys(objA);
      var keysB = Object.keys(objB);
      if (keysA.length !== keysB.length) {
        return false;
      }
      for (var i = 0; i < keysA.length; i++) {
        var key = keysA[i];
        if (keysB.indexOf(key) === -1) {
          return false;
        }
        if (objA[key] !== objB[key]) {
          return false;
        }
      }
      return true;
    },
    empty: function empty() {
      return {};
    },
    concat: function concat(objA, objB) {
      return babelHelpers$1.extends({}, objA, objB);
    },
    toArray: function toArray(objX) {
      return Object.keys(objX).map(function (key) {
        return objX[key];
      });
    },
    sequence: function sequence(T, objT) {
      return flow(objT, SObject.toPairs, SArray.map(SPair.sequence(T)), SArray.sequence(T), T.map(SObject.fromPairs));
    },
    ap: function ap(objF, objX) {
      var applyX = function applyX(pair) {
        return SPair.map(function (fn) {
          return fn(objX[SPair.second(pair)]);
        }, pair);
      };
      return flow(objF, SObject.toPairs, SArray.map(applyX), SObject.fromPairs);
    },
    toPairs: function toPairs(objX) {
      return Object.keys(objX).map(function (key) {
        return SPair.create(objX[key], key);
      });
    },
    fromPairs: function fromPairs(pairs) {
      var result = {};
      pairs.forEach(function (pair) {
        result[SPair.second(pair)] = SPair.first(pair);
      });
      return result;
    }
  });

  function composeWithInnerType(I) {

    var sequenceIS = I.sequence(Stream);
    var joinI = I.chain(function (x) {
      return x;
    });

    var Composed = fromIncomplete({
      of: function of(x) {
        return Stream.of(I.of(x));
      },
      map: function map(fn, composed) {
        return Stream.map(I.map(fn), composed);
      },
      ap: function ap(composedf, composedx) {
        return Stream.ap(Stream.map(I.ap, composedf), composedx);
      },
      chain: function chain(fn, composed) {
        return Stream.chain(function (inner) {
          return Stream.map(joinI, sequenceIS(I.map(fn, inner)));
        }, composed);
      }
    });

    return Composed;
  }

  /*
  // [composed]
  chainLatest(fn) {
    // Copy-pasted from .chain, and replaced .chain -> .chainLatest
    // Not sure at all if this is correct or at least works...
    return this.withUncomposed(
      si => si.chainLatest(i => {
        const isi = i[map](x => fn(x).uncompose())
        const sii = isi[sequence](Stream.of)
        const si = sii[map](ii => ii[chain](i => i))
        return si
      })
    )
  }

  // [composed]
  startWith(x) {
    return this.withUncomposed(stream => stream.startWith(Inner[of](x)))
  }
  */

  // We're not sure yet if this function should be public
  function fromArray(xs) {
    return function (sink) {
      xs.forEach(function (x) {
        sink(x);
      });
      return function () {};
    };
  }

  var Stream = fromIncomplete({

    /* Creates an empty stream
     */

    empty: function empty() {
      return function () {
        return function () {};
      };
    },


    /* Merges several streams of same type to a single stream of that type.
     * The result stream will contain values from all streams
     */
    concat: function concat(streams) {
      return Stream.chain(function (x) {
        return x;
      })(fromArray(streams));
    },


    /* Creates a stream containing given value
     */
    of: function of(x) {
      return function (sink) {
        sink(x);
        return function () {};
      };
    },


    /* Lifts function `A => B` to a function that operates
     * on streams `Stream<A> => Stream<B>`
     */
    map: function map(fn, stream) {
      return function (sink) {
        return stream(function (payload) {
          return sink(fn(payload));
        });
      };
    },


    /* Given a stream of functions `Stream<A => B>`, returns a function
     * that operates on streams `Stream<A> => Stream<B>`.
     * The result stream `Stream<B>` will contain values created by applying
     * the latest function from `Stream<A => B>` to the latest value from `Stream<A>`
     * every time one of them updates.
     */
    ap: function ap(streamf, streamv) {
      return function (sink) {
        var latestF = { type: 'nothing' };
        var latestV = { type: 'nothing' };
        var push = function push() {
          if (latestF.type === 'just' && latestV.type === 'just') {
            var fn = latestF.value;
            sink(fn(latestV.value));
          }
        };
        var disposef = streamf(function (f) {
          latestF = { type: 'just', value: f };
          push();
        });
        var disposev = streamv(function (v) {
          latestV = { type: 'just', value: v };
          push();
        });
        return function () {
          disposef();
          disposev();
        };
      };
    },


    /* Given a function `A => Stream<B>` returns a function
     * that operates on streams `Stream<A> => Stream<B>`.
     * The result function will spawn a `Stream<B>`
     * for each value from `Stream<A>` using the provided function.
     * The final `Stream<B>` will contain values from all spawned streams.
     */
    chain: function chain(fn, stream) {
      return function (sink) {
        var spawnedDisposers = [];
        var mainDisposer = stream(function (payload) {
          spawnedDisposers.push(fn(payload)(sink));
        });
        return function () {
          spawnedDisposers.forEach(function (fn) {
            return fn();
          });
          mainDisposer();
        };
      };
    },


    /* Given an array of streams returns a stream of arrays.
     */
    combineArray: function combineArray(arr) {
      return SArray.sequence(Stream, arr);
    },


    /* Given an object (a.k.a map/hash/dictionary) of streams returns a stream of objects.
     * Same as combineArray but for objects.
     */
    combineObject: function combineObject(obj) {
      return SObject.sequence(Stream, obj);
    },


    /* Given a loose basic-stream, that obeys at least following laws:
     *
     *   1. Stream is a function,
     *   2. It accepts one argument, the subscriber function (aka `sink`);
     *
     * returns a valid basic-steam, that obeys all laws of a stream from protocol,
     * and also immune to violations of any of usage laws except:
     *
     *   2. `sink` must be a function
     */
    fromLoose: function fromLoose(looseStream) {
      return function (_sink) {
        var sink = _sink;
        var disposer = looseStream(function (x) {
          // fix usage #1
          if (sink !== null) {
            // fix stream #6
            sink(x); // fix stream #4
          }
          // fix usage #3
        });
        return function () {
          // fix stream #3
          if (sink === null) {
            // fix usage #5
            return;
          }
          sink = null;
          if (typeof disposer === 'function') {
            // fix stream #3
            disposer(); // fix usage #4
          }
          disposer = null;
          // fix stream #5
        };
      };
    },


    /* Given a predicate `A => boolean` returns a function
     * that operates on streams `Stream<A> => Stream<A>`.
     * The result function returns a stream without values that don't satisfy predicate.
     */
    filter: function filter(predicate, stream) {
      return function (sink) {
        return stream(function (payload) {
          if (predicate(payload)) {
            sink(payload);
          }
        });
      };
    },


    /* Same as `chain()`, except the final stream will contain
     * only that values from each spawned streams that was
     * emitted before the next stream was spawned.
     */
    chainLatest: function chainLatest(fn, stream) {
      return function (sink) {
        var spawnedDisposers = function spawnedDisposers() {};
        var mainDisposer = stream(function (payload) {
          spawnedDisposers();
          spawnedDisposers = fn(payload)(sink);
        });
        return function () {
          spawnedDisposers();
          mainDisposer();
        };
      };
    },


    /* Given a reducer function `(B, A) => B`, and a seed value of type B,
     * returns a function that operates on streams `Stream<A> => Stream<B>`.
     * Will apply reducer to each value in `Stream<A>` and push the result to `Stream<B>`
     */
    scan: function scan(reducer, seed, stream) {
      return function (sink) {
        var current = seed;
        sink(current);
        return stream(function (x) {
          current = reducer(current, x);
          sink(current);
        });
      };
    },


    /* Given a number N, returns a function that operates on streams `Stream<A> => Stream<A>`.
     * The result stream will contain only first N items from source stream
     */
    take: function take(n, stream) {
      return function (sink) {
        var count = 0;
        var disposer = null;
        var dispose = function dispose() {
          if (disposer !== null) {
            disposer();
            disposer = null;
          }
        };
        disposer = stream(function (x) {
          count++;
          if (count <= n) {
            sink(x);
          }
          if (count >= n) {
            dispose();
          }
        });
        if (count >= n) {
          dispose();
        }
        return dispose;
      };
    },


    /* Given a predicate `A => boolean` returns a function
     * that operates on streams `Stream<A> => Stream<A>`.
     * The result stream will contain values from source stream
     * before the first value that doesn't satisfy predicate.
     */
    takeWhile: function takeWhile(pred, stream) {
      return function (sink) {
        var completed = false;
        var disposer = null;
        var dispose = function dispose() {
          if (disposer !== null) {
            disposer();
            disposer = null;
          }
        };
        disposer = stream(function (x) {
          if (!completed) {
            if (pred(x)) {
              sink(x);
            } else {
              completed = true;
              dispose();
            }
          }
        });
        if (completed) {
          dispose();
        }
        return dispose;
      };
    },


    /* Given a controller stream, returns a function that operates
     * on streams `Stream<A> => Stream<A>`. The result stream will contain values
     * from source stream until the first value from controller stream.
     */
    takeUntil: function takeUntil(controller, stream) {
      return function (sink) {
        var mainDisposer = null;
        var ctrlDisposer = null;
        var dispose = function dispose() {
          if (mainDisposer !== null) {
            mainDisposer();
            mainDisposer = null;
          }
          if (ctrlDisposer !== null) {
            ctrlDisposer();
            ctrlDisposer = null;
          }
        };

        mainDisposer = stream(sink);
        ctrlDisposer = controller(dispose);

        // in case controller cb was called sync before we obtained ctrlDisposer
        if (mainDisposer === null) {
          dispose();
        }

        return dispose;
      };
    },


    /* Given a number N, returns a function that operates on streams `Stream<A> => Stream<A>`.
     * The result stream will contain only items from source starting from (N+1)th one
     */
    skip: function skip(n, stream) {
      return function (sink) {
        var count = 0;
        return stream(function (x) {
          count++;
          if (count > n) {
            sink(x);
          }
        });
      };
    },


    /* Given a predicate `A => boolean` returns a function
     * that operates on streams `Stream<A> => Stream<A>`.
     * The result stream will contain values from source stream
     * starting from the first that doesn't satisfy predicate.
     */
    skipWhile: function skipWhile(pred, stream) {
      return function (sink) {
        var started = false;
        return stream(function (x) {
          if (!started) {
            started = !pred(x);
          }
          if (started) {
            sink(x);
          }
        });
      };
    },


    /* Given a comparator function `(A, A) => boolean` returns a function that
     * operates on streams `Stream<A> => Stream<A>`. For each element X from
     * the source stream (except the first one) calls comparator with (Y, X)
     * as arguments, where Y is the last element in the result stream.
     * If comparator returns false, X goes to the result stream.
     */
    skipDuplicates: function skipDuplicates(comp, stream) {
      return function (sink) {
        var latest = { type: 'nothing' };
        return stream(function (x) {
          if (latest.type === 'nothing' || !comp(latest.value, x)) {
            latest = { type: 'just', value: x };
            sink(x);
          }
        });
      };
    },


    /* Given a stream returns a new stream of same type. The new stream will
     * have at most one subscription at any given time to the original stream.
     * It allows you to connect several subscribers to a stream using only one subscription.
     */
    multicast: function multicast(stream) {
      var sinks = [];
      var push = function push(x) {
        sinks.forEach(function (sink) {
          if (sinks.indexOf(sink) !== -1) {
            sink(x);
          }
        });
      };
      var unsub = null;
      return function (sink) {
        var disposed = false;
        sinks = [].concat(babelHelpers.toConsumableArray(sinks), [sink]);
        if (sinks.length === 1) {
          unsub = stream(push);
        }
        return function () {
          if (disposed) {
            return;
          }
          disposed = true;
          var index = sinks.indexOf(sink);
          sinks = [].concat(babelHelpers.toConsumableArray(sinks.slice(0, index)), babelHelpers.toConsumableArray(sinks.slice(index + 1, sinks.length)));
          if (sinks.length === 0 && unsub !== null) {
            unsub();
            unsub = null;
          }
        };
      };
    },


    /* Given a value of type `A` returns a function that
     * operates on streams `Stream<A> => Stream<A>`.
     * The result stream is a copy of source stream
     * with the given value added at the beginning.
     */
    startWith: function startWith(x, stream) {
      return function (sink) {
        sink(x);
        return stream(sink);
      };
    },


    /* Given a transducer that conforms [Protocol][1],
     * returns a function that operates on streams `Stream<A> => Stream<B>`.
     *
     * [1]: https://github.com/cognitect-labs/transducers-js#the-transducer-protocol
     */
    transduce: function transduce(transducer, stream) {
      return function (sink) {
        var thisDisposed = false;
        var sourceDisposer = null;

        var transformer = transducer({
          '@@transducer/result': function transducerResult() {},
          '@@transducer/step': function transducerStep(result, input) {
            if (!thisDisposed) {
              sink(input);
            }
            return result;
          }
        });

        var disposeSource = function disposeSource() {
          if (sourceDisposer !== null) {
            sourceDisposer();
            sourceDisposer = null;
          }
        };

        sourceDisposer = stream(function (x) {
          if (transformer === null) {
            return;
          }

          // it returns either null or tReduced<null>
          if (null !== transformer['@@transducer/step'](null, x)) {
            transformer['@@transducer/result'](null);
            transformer = null;
            disposeSource();
          }
        });

        if (transformer === null) {
          disposeSource();
        }

        return function () {
          thisDisposed = true;
          disposeSource();
        };
      };
    },


    composeWithInnerType: composeWithInnerType

  });

  var Stream$1 = function () {

    // Example:
    //
    //    const myWrappedStream = new Stream(sink => {
    //      sink(1)
    //      retrun () => {}
    //    })
    //

    function Stream$$(basicStream) {
      babelHelpers.classCallCheck(this, Stream$$);


      // The wrapped BasicStream is available as `wrapped.observe`.
      // You can call it as a method in order to subscribe to the stream:
      //
      //    const usub = wrapped.observe(callback)
      //    unsub()
      //
      // Or you can use `wrapped.observe` to extract BasicStream from the wrapper e.g.:
      //
      //    const basicStream2 = map(x => x * 2)(wrapped.observe)
      //
      this.observe = Stream.fromLoose(basicStream);
    }

    // Semigroup


    babelHelpers.createClass(Stream$$, [{
      key: fl.concat,
      value: function value(other) {
        return new Stream$$(Stream.concat([this.observe, other.observe]));
      }

      // Monoid

    }, {
      key: fl.empty,
      value: function value() {
        return Stream$$.empty();
      }

      // Functor

    }, {
      key: fl.map,
      value: function value(f) {
        return new Stream$$(Stream.map(f)(this.observe));
      }

      // Apply

    }, {
      key: fl.ap,
      value: function value(other) {
        var streamF = this.observe;
        return new Stream$$(Stream.ap(streamF)(other.observe));
      }

      // Applicative

    }, {
      key: fl.of,
      value: function value(x) {
        return Stream$$.of(x);
      }

      // Monad

    }, {
      key: fl.chain,
      value: function value(f) {
        return new Stream$$(Stream.chain(function (x) {
          return f(x).observe;
        })(this.observe));
      }

      // ------------------ Not from FL ------------------

    }, {
      key: 'filter',
      value: function filter(f) {
        return new Stream$$(Stream.filter(f)(this.observe));
      }
    }, {
      key: 'scan',
      value: function scan(f, seed) {
        return new Stream$$(Stream.scan(f, seed)(this.observe));
      }
    }, {
      key: 'chainLatest',
      value: function chainLatest(f) {
        return new Stream$$(Stream.chainLatest(function (x) {
          return f(x).observe;
        })(this.observe));
      }
    }, {
      key: 'take',
      value: function take(n) {
        return new Stream$$(Stream.take(n)(this.observe));
      }
    }, {
      key: 'takeWhile',
      value: function takeWhile(f) {
        return new Stream$$(Stream.takeWhile(f)(this.observe));
      }
    }, {
      key: 'takeUntil',
      value: function takeUntil(other) {
        return new Stream$$(Stream.takeUntil(other.observe)(this.observe));
      }
    }, {
      key: 'skip',
      value: function skip(n) {
        return new Stream$$(Stream.skip(n)(this.observe));
      }
    }, {
      key: 'skipWhile',
      value: function skipWhile(f) {
        return new Stream$$(Stream.skipWhile(f)(this.observe));
      }
    }, {
      key: 'skipDuplicates',
      value: function skipDuplicates(f) {
        return new Stream$$(Stream.skipDuplicates(f)(this.observe));
      }
    }, {
      key: 'multicast',
      value: function multicast() {
        return new Stream$$(Stream.multicast(this.observe));
      }
    }, {
      key: 'startWith',
      value: function startWith(x) {
        return new Stream$$(Stream.startWith(x)(this.observe));
      }
    }, {
      key: 'transduce',
      value: function transduce(transducer) {
        return new Stream$$(Stream.transduce(transducer)(this.observe));
      }
    }], [{
      key: fl.empty,
      value: function value() {
        return new Stream$$(Stream.empty());
      }
    }, {
      key: fl.of,
      value: function value(x) {
        return new Stream$$(Stream.of(x));
      }
    }, {
      key: 'map2',
      value: function map2(f) {
        var lifted = Stream.map2(f);
        return function (sA, sB) {
          return new Stream$$(lifted(sA.observe, sB.observe));
        };
      }
    }, {
      key: 'map3',
      value: function map3(f) {
        var lifted = Stream.map3(f);
        return function (sA, sB, sC) {
          return new Stream$$(lifted(sA.observe, sB.observe, sC.observe));
        };
      }
    }, {
      key: 'combineArray',
      value: function combineArray(arr) {
        return new Stream$$(Stream.combineArray(arr.map(function (x) {
          return x.observe;
        })));
      }
    }, {
      key: 'combineObject',
      value: function combineObject(obj) {
        var ofBasicStreams = {};
        Object.keys(obj).forEach(function (key) {
          ofBasicStreams[key] = obj[key].observe;
        });
        return new Stream$$(Stream.combineObject(ofBasicStreams));
      }
    }]);
    return Stream$$;
  }();

  exports.Stream = Stream;
  exports.FantasyStream = Stream$1;

}));